#include <sys/wait.h>

#include "signals.h"

#include <cstdio>
#include <cstring>
#include <cerrno>

// Signal Handlers
static pid_t guest_pid = -1;
static void exit_handler(__attribute__((unused)) int signal_id) {
    // Stop Child
    kill(guest_pid, SIGTERM);
}

// Init
void init_signals(pid_t pid) {
    guest_pid = pid;
    // Install Signal Handlers
    struct sigaction act_sigint = {};
    act_sigint.sa_flags = SA_RESTART;
    act_sigint.sa_handler = &exit_handler;
    sigaction(SIGINT, &act_sigint, nullptr);
    struct sigaction act_sigterm = {};
    act_sigterm.sa_flags = SA_RESTART;
    act_sigterm.sa_handler = &exit_handler;
    sigaction(SIGTERM, &act_sigterm, nullptr);
}